<template>
    <div v-show="spinnerVisible" class="mask">
        <span class="spinner">요청하신 작업 진행중입니다.</span>
    </div>
</template>

<script lang="ts">

    import {Vue}          from 'vue-property-decorator';
    import {Prop}         from 'vue-property-decorator';
    import {Component}    from 'vue-property-decorator';
    import {SpinnerEvent} from '@/io/niceday/common/engine/event/SpinnerEvent';

    @Component
    export default class Spinner extends Vue {

        public spinnerVisible: boolean = false;

        public created() {
            SpinnerEvent.$on('before-request', this.showSpinner);
            SpinnerEvent.$on('request-error',  this.hideSpinner);
            SpinnerEvent.$on('after-response', this.hideSpinner);
            SpinnerEvent.$on('response-error', this.hideSpinner);
        }

        public beforeDestroy () {
            SpinnerEvent.$off('before-request', this.showSpinner);
            SpinnerEvent.$off('response-error', this.hideSpinner);
            SpinnerEvent.$off('request-error',  this.hideSpinner);
            SpinnerEvent.$off('after-response', this.hideSpinner);
        }

        public showSpinner(): void {
            this.spinnerVisible = true;
        }

        public hideSpinner(): void {
            this.spinnerVisible = false;
        }
    }
</script>

<style scoped>
    .mask {
        opacity: 0.7;
        width: 100%;
        height: 100%;
        position: absolute;
        z-index: 9000;
        background-color: #000000;
        left: 0;
        top: 0;
    }

    .spinner {
        position: absolute;
        left: 40%;
        top: 40%;
        z-index: 10000;
        font-weight: bold;
        font-size: 30px;
        color: aliceblue;
        background-color: crimson;
    }
</style>
